/*******************************************************************************************
This file is part of iToday.

iToday is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

iToday is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with iContact.  If not, see <http://www.gnu.org/licenses/>.
* ------------------------------------------------------------------------------
*    ApplicationPanel.cpp - Class ApplicationPanel implement
* ------------------------------------------------------------------------------
*    Revision History
*    Date                  Author         Activity ID               Activity Headline
*    2009-10-13            Congqin				none						initial
*******************************************************************************************/


#include "stdafx.h"

#include <imaging.h>
#include <imgguids.h>

//static HPHYSICSENGINE g_hPhysicsEngine = NULL;

ApplicationPanel::ApplicationPanel(HWND hWnd, HINSTANCE hInstance)
        :PanelBase( hWnd, hInstance)
{

}

BOOL ApplicationPanel::InitMemoryDC()
{
    DebugPrintString(L"Thread1: into ApplicationPanel::InitMemoryDC() \n" );

    m_hMemoryDC = CreateCompatibleDC( m_hRealDC );
    if ( NULL == m_hMemoryDC)
    {
        DebugPrintString(L"create the m_hMemoryDC is failure! " );
        return FALSE;
    }

    m_hMemoryBm = CreateCompatibleBitmap( m_hRealDC, m_rcScreen.right, 2 * m_rcScreen.bottom );
    if ( NULL == m_hMemoryBm )
    {
        DebugPrintString(L"create the m_hMemoryBm is failure! ! " );
        return FALSE;
    }
    SelectObject(m_hMemoryDC,m_hMemoryBm);

    DrawMemoryDC();

    return TRUE;

}

void ApplicationPanel::DrawMemoryDC ()
{
    DebugPrintString(L"Thread1: into ApplicationPanel::DrawMemoryDC() \n" );

    TCHAR* pBackGroud	= RES_PATH("background.bmp");
    TCHAR* pAPPMenPhotoFile[] =
    {
        RES_PATH("Start_Icon_Calendar.png"),
        RES_PATH("Start_Icon_FileExp.png"),
        RES_PATH("Start_Icon_Games.png"),
        RES_PATH("Start_Icon_GPS.png"),
        RES_PATH("Start_Icon_IE.png"),
        RES_PATH("Start_Icon_WMP.png"),
        RES_PATH("Start_Icon_Msg.png"),
        RES_PATH("Start_Icon_Notes.png"),
        RES_PATH("Start_Icon_Office.png"),
        RES_PATH("Start_Icon_Phone.png"),
        RES_PATH("Start_Icon_Search.png"),
        RES_PATH("Start_Icon_Settings.png"),
        RES_PATH("Start_Icon_TaskMgr.png"),
        RES_PATH("Start_Icon_Welcome.png"),
        RES_PATH("Start_Icon_WinLive.png"),
        RES_PATH("Start_Icon_SMS.png"),
        RES_PATH("Start_Icon_Async.png"),
        RES_PATH("Start_Icon_Calc.png"),
        RES_PATH("Start_Icon_Camera.png"),
        RES_PATH("Start_Icon_Help.png"),
        RES_PATH("Start_Icon_IS.png"),
        RES_PATH("Start_Icon_Marketplace.png"),
        RES_PATH("Start_Icon_MyPhone.png"),
        RES_PATH("Start_Icon_Tasks.png"),
    };

    RECT rect	= { 0,0,0,0 };
    LONG lTemp	= 0;

    DrawImageClass*  drawDC = new DrawImageClass();

    if ( m_rcScreen.right < (m_rcScreen.bottom - m_rcScreen.right/5) )
    {
        lTemp = m_rcScreen.right ;
    }
    else
    {
        lTemp = m_rcScreen.bottom - m_rcScreen.right/5;
    }

    drawDC ->DrawImageToDC (m_hMemoryDC , m_rcScreen, pBackGroud );

    for (int i=0; i < SIZEBUFFER( pAPPMenPhotoFile ); i++)
    {
        rect.top	= ( i/4 ) * ( lTemp / 5 ) + (lTemp / 25 ) * ( 1 + i / 4 );
        rect.bottom = rect.top + ( lTemp / 5 );
        rect.left   = ( m_rcScreen.right / 5 )*( i % 4 ) + ( m_rcScreen.right / 25 ) * ( 1 + i % 4 );
        rect.right  = rect.left + ( m_rcScreen.right / 5 );

        drawDC ->DrawImageToDC ( m_hMemoryDC , rect, pAPPMenPhotoFile[i] );

    }

    delete drawDC;
    return;

}

void ApplicationPanel::Draw()
{

    BitBlt( m_hPublicMemoryDC,
            0,
            0,
            m_rcScreen.right,
            m_rcScreen.bottom - m_rcScreen.right/5,
            m_hMemoryDC,
            0,
            0,
            SRCCOPY);

    return ;
}

ApplicationPanel::~ApplicationPanel()
{
    DELETE_OBJ(m_hMemoryBm);
    DELETE_OBJ(m_hMemoryDC);
}

BOOL ApplicationPanel::DrawMouseDownMenu(POINT pt, HDC hPublicMemoryDC, RECT &rcClickedRegion)
{
    RECT	rect={ 0, 0, 0, 0 };
    long	lTemp;
    HDC		hdc = GetDC( m_hWnd );

    if ( m_rcScreen.right< ( m_rcScreen.bottom - m_rcScreen.right/5 ) )
    {
        lTemp = m_rcScreen.right ;
    }
    else
    {
        lTemp = m_rcScreen.bottom - m_rcScreen.right/5;
    }

    for (int i=0; i< 24; i++)
    {
        rect.top	= ( i/4 ) * ( lTemp / 5 )+(lTemp / 25 ) * ( 1 + i / 4 );
        rect.bottom = rect.top+( lTemp / 5 );
        rect.left   = ( m_rcScreen.right / 5 ) * ( i % 4 )+( m_rcScreen.right / 25 ) * ( 1 + i % 4 );
        rect.right  = rect.left+( m_rcScreen.right / 5 );

        if ( PtInRect(&rect, pt ) )
        {
            if ( rect.bottom > m_rcScreen.bottom - m_rcScreen.right/5 )
                rect.bottom = m_rcScreen.bottom - m_rcScreen.right/5;

            BitBlt(m_hPublicMemoryDC,
                   rect.left,
                   rect.top,
                   rect.right-rect.left,
                   rect.bottom-rect.top,
                   hPublicMemoryDC,
                   rect.left,
                   rect.top,
                   SRCCOPY
                  );

            AlphaBlt(m_hPublicMemoryDC,
                     rect.left,
                     rect.top,
                     rect.right-rect.left,
                     rect.bottom-rect.top,
                     m_hMemoryDC,
                     rect.left,
                     rect.top,
                     rect.right-rect.left,
                     rect.bottom-rect.top,
                     150);

            DrawMemDCToCurrentDC( m_hRealDC, m_hPublicMemoryDC, m_rcScreen );

            rcClickedRegion = rect;

            return TRUE;
        }

    }

    return FALSE ;
}

BOOL ApplicationPanel::DrawMouseUpMenu(POINT pt, RECT &rcClickedRegion)
{

    if (	rcClickedRegion.left == 0 &&
            rcClickedRegion.top	== 0 &&
            rcClickedRegion.right == 0 &&
            rcClickedRegion.bottom== 0
       )
    {
        return TRUE;
    }

    BitBlt( m_hPublicMemoryDC,
            rcClickedRegion.left,
            rcClickedRegion.top,
            rcClickedRegion.right - rcClickedRegion.left,
            rcClickedRegion.bottom - rcClickedRegion.top,
            m_hMemoryDC ,
            rcClickedRegion.left,
            rcClickedRegion.top,
            SRCCOPY
          );

    DrawMemDCToCurrentDC( m_hRealDC, m_hPublicMemoryDC, m_rcScreen );

    //if( pt.x <= rcClickedRegion.right && pt.x >= rcClickedRegion.left
    //	&& pt.y <= rcClickedRegion.bottom && pt.y >= rcClickedRegion.top )
    //{
    //	//  ............

    //}

    return TRUE;
}

void ApplicationPanel::SnapBackToFrame()
{}

HRESULT ApplicationPanel::ProcessPanEnd( int nTransitionSpeed, DWORD   nTransitionAngle )
{
    return S_OK;
}

BOOL ApplicationPanel::ProcessPan(POINTS& pt)
{
    return TRUE;
}

BOOL ApplicationPanel::ProcessAnimationTimer()
{
    return TRUE;
}

BOOL ApplicationPanel::RecordLastPanPoint( POINTS& pt )
{
    return TRUE;
}

BOOL ApplicationPanel::CalculateStartPointInMemDC( POINTS& pt )
{
    return TRUE;
}