/*******************************************************************************************
This file is part of iToday.

iToday is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

iToday is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with iContact.  If not, see <http://www.gnu.org/licenses/>.
* ------------------------------------------------------------------------------
*    ContactPanel.cpp - Class ContactPanel implement
* ------------------------------------------------------------------------------
*    Revision History
*    Date                  Author         Activity ID               Activity Headline
*    2009-10-13            Congqin				none						initial
*	 2009-11-4			   Congqin				none                 ʵContactListData
*******************************************************************************************/

#include "stdafx.h"

//#include <initguid.h>   // For COM INIT_GUID defns
#include <pimstore.h>   // POOM header file

// cache file's name
const TCHAR* szFileName = TEXT("contact.dat");


ContactPanel::ContactPanel(HWND hWnd, HINSTANCE hInstance):PanelBase( hWnd, hInstance)
{
    m_ItemFont = BuildFont( ITEM_FONT_SIZE, TRUE, FALSE);
    m_Offset = 0;
    m_IsCategoryState = FALSE;

    _tcscpy( m_szCurrentCategoryName, TEXT("All Contact") );

    SetRect( &m_rcIn_MenuBar, m_rcScreen.right - m_rcScreen.right / 16 ,
             m_rcScreen.bottom / 8, m_rcScreen.right,m_rcScreen.bottom / 2 );

    SetRect( &m_rcOut_MenuPanel, m_rcScreen.right - m_rcScreen.right / 16 * 3 ,
             m_rcScreen.bottom / 8, m_rcScreen.right,m_rcScreen.bottom / 2 );
    m_eMenuState = eMenuIn;

    CopyRect( &m_rcOut_MenuBar, &m_rcOut_MenuPanel );
    CopyRect( &m_rcOut_MenuRegion, &m_rcOut_MenuPanel );
    m_rcOut_MenuBar.right = m_rcOut_MenuBar.left + m_rcIn_MenuBar.right - m_rcIn_MenuBar.left ;
    m_rcOut_MenuRegion.left  = m_rcOut_MenuBar.right ;

    InitMemoryDC();
}


BOOL ContactPanel::InitMemoryDC()
{
    m_hMemoryDC = CreateCompatibleDC( m_hRealDC );
    if ( NULL == m_hMemoryDC)
    {
        DebugPrintString(L"create the m_hMemoryDC is failure! " );
        return FALSE;
    }

    m_hMemoryBm = CreateCompatibleBitmap( m_hRealDC, m_rcScreen.right,
                                          m_rcScreen.bottom * 3 / 2 );

    if ( NULL == m_hMemoryBm )
    {
        DebugPrintString(L"create the m_hMemoryBm is failure! ! " );
        return FALSE;
    }
    SelectObject( m_hMemoryDC, m_hMemoryBm );

    DrawMemoryDC();

    return TRUE;

}


BOOL ContactPanel::DrawMemoryDC()
{
    COLORREF 	c = RGB( 180, 180, 180 );
    COLORREF	clrSave = SetBkColor(m_hMemoryDC, c);
    RECT        rect;
    TCHAR *     szMenuPhoto = L"\\Windows\\Contact_Menu.png";

    SetRect( &rect, m_rcScreen.left , m_rcScreen.bottom ,
             m_rcOut_MenuPanel.right  - m_rcOut_MenuPanel.left,
             m_rcScreen.bottom + m_rcOut_MenuPanel.bottom - m_rcOut_MenuPanel.top  );

    ExtTextOut( m_hMemoryDC, 0, 0, ETO_OPAQUE, &m_rcScreen, NULL, 0, NULL );

    SetBkColor( m_hMemoryDC, clrSave );

    DrawImage( m_hMemoryDC, rect, szMenuPhoto );

    return TRUE;

}

void ContactPanel::Draw()
{
    m_SelectedItem = m_Offset;
    LONG  lContactTxtHeight = 0;

    m_ContactListData.m_hCache = INVALID_HANDLE_VALUE;
    m_ContactListData.ListLoad( szFileName,true);

    if ( m_IsCategoryState == FALSE )
    {
        lContactTxtHeight = DrawContactTxt();
    }
    else
    {
        PoomCategoriesPopulate( m_ContactListData.m_vContactListCategory );
        lContactTxtHeight = DrawCategoryTxt();
    }

// set background
    RECT		rect;
    CopyRect( &rect, &m_rcScreen );
    rect.bottom = rect.bottom - rect.right / 5;
    COLORREF 	c = RGB( 0, 0, 0 );
    COLORREF	clrSave = SetBkColor(m_hPublicMemoryDC, c);

    ExtTextOut( m_hPublicMemoryDC, 0,0, ETO_OPAQUE, &rect,
                0,0, NULL );

    SetBkColor( m_hPublicMemoryDC, clrSave );

    BitBlt( m_hPublicMemoryDC,
            0,
            0,
            m_rcScreen.right,
            lContactTxtHeight,
            m_hMemoryDC,
            0,
            0,
            SRCCOPY);

    BitBlt( m_hMemoryDC, //汻menuסĲ
            m_rcScreen.right / 2,
            m_rcScreen.bottom ,
            m_rcOut_MenuPanel.right - m_rcOut_MenuPanel.left ,
            m_rcOut_MenuPanel.bottom - m_rcOut_MenuPanel.top ,
            m_hPublicMemoryDC,
            m_rcOut_MenuPanel.left,
            m_rcOut_MenuPanel.top,
            SRCCOPY
          );
// ensure  the station of the menu_panel
    if ( m_eMenuState == eMenuIn )
    {
        BitBlt( m_hPublicMemoryDC,
                m_rcIn_MenuBar.left,
                m_rcIn_MenuBar.top ,
                m_rcIn_MenuBar.right - m_rcIn_MenuBar.left ,
                m_rcIn_MenuBar.bottom - m_rcIn_MenuBar.top ,
                m_hMemoryDC,
                0,
                m_rcScreen.bottom,
                SRCCOPY);
    }
    else
    {
        BitBlt( m_hPublicMemoryDC,
                m_rcOut_MenuPanel.left ,
                m_rcOut_MenuPanel.top ,
                m_rcOut_MenuPanel.right - m_rcOut_MenuPanel.left ,
                m_rcOut_MenuPanel.bottom - m_rcOut_MenuPanel.top ,
                m_hMemoryDC,
                0,
                m_rcScreen.bottom,
                SRCCOPY);
    }

    return;
}

LONG ContactPanel::DrawContactTxt()
{
    RECT  rect;
    int   count = m_Offset;

    rect.bottom = m_rcScreen.top ;
    rect.top = m_rcScreen.top ;


    while ( count <m_ContactListData.GetItemCount() &&
            rect.bottom <= m_rcScreen.bottom - m_rcScreen.right/5 )
    {
        if (  wcscmp( m_szCurrentCategoryName ,TEXT("All Contact")) == 0 ||
                wcscmp( m_szCurrentCategoryName,m_ContactListData.m_vContactListItems[count].szCategoriesText )==0 )
        {
            SetRect( &rect, m_rcScreen.left ,rect.bottom + ONE,
                     m_rcScreen.right ,rect.bottom + ONE + CONTACT_ITEM_HEIGHT );
            DrawItem( rect, m_ContactListData.GetItem(count).szPrimaryText );
        }
        count++;
    }

    return rect.bottom + ONE;
}

LONG ContactPanel::DrawCategoryTxt()
{
    RECT  rect;
    int   count = m_Offset;

    rect.bottom = m_rcScreen.top ;
    rect.top = m_rcScreen.top ;

    while ( count < (m_ContactListData.m_vContactListCategory.size()) &&
            rect.bottom <= m_rcScreen.bottom - m_rcScreen.right/5  )
    {
        SetRect( &rect, m_rcScreen.left ,rect.bottom + ONE,
                 m_rcScreen.right ,rect.bottom + ONE + CONTACT_ITEM_HEIGHT );
        DrawItem( rect, m_ContactListData.m_vContactListCategory[count].m_szCurrentCategoryName );
        count++;
    }

    return rect.bottom + ONE;
}


BOOL ContactPanel::DrawItem( RECT rect, TCHAR* szItemName)
{
    COLORREF 	c = RGB(130,130,130);
    COLORREF	clrSave = SetBkColor(m_hMemoryDC, c);

    c = RGB( 0,0,0 );
    SelectObject(m_hMemoryDC, m_ItemFont );
    SetTextColor(m_hMemoryDC, c);

    ExtTextOut( m_hMemoryDC, m_rcScreen.right / 20 ,
                rect.top , ETO_OPAQUE, &rect,
                szItemName ,
                _tcslen( szItemName ), NULL );

    SetBkColor( m_hMemoryDC, clrSave );

    return TRUE;

}

BOOL	ContactPanel::DrawMouseDownMenu( POINT pt )
{
    m_pPreDown.x = pt.x;
    m_pPreDown.y = pt.y ;

    switch ( m_eMenuState )
    {
    case eMenuIn:
        if ( PtInRect( &m_rcIn_MenuBar, pt) )
        {
            //............
        }
        else
            ProcessDownContactRegion( pt );
        break;
    case eMenuOut:
        if ( PtInRect( &m_rcOut_MenuPanel, pt) )
        {
            RECT rect;
            CopyRect( &rect, &m_rcOut_MenuRegion );
            rect.bottom = rect.top ;
            for (int i=0; i<4; i++ )
            {
                rect.top  = rect.bottom ;
                rect.bottom = rect.top +
                              ( m_rcOut_MenuRegion.bottom - m_rcOut_MenuRegion.top  ) / 4 ;

                if ( PtInRect( &rect, pt ))
                {
                    COLORREF	c = RGB( 85, 49, 2 );
                    COLORREF	cSave= SetBkColor(m_hPublicMemoryDC, c);
                    ExtTextOut( m_hPublicMemoryDC, 0 ,0 , ETO_OPAQUE, &rect,
                                0,0, NULL );
                    SetBkColor( m_hPublicMemoryDC, cSave );

                    AlphaBlt(	m_hPublicMemoryDC,
                              rect.left,
                              rect.top,
                              rect.right - rect.left,
                              rect.bottom - rect.top,
                              m_hMemoryDC,
                              m_rcIn_MenuBar.right - m_rcIn_MenuBar.left,
                              m_rcScreen.bottom +
                              ( m_rcOut_MenuRegion.bottom -
                                m_rcOut_MenuRegion.top  ) / 4 * i  ,
                              rect.right - rect.left,
                              rect.bottom - rect.top,
                              150);
                    break;
                }
            }
        }
        else
            ProcessDownContactRegion( pt );
        break;
    default:
        break;
    }
    DrawMemDCToCurrentDC( m_hRealDC, m_hPublicMemoryDC, m_rcScreen );

    return TRUE;
}

BOOL  ContactPanel::ProcessDownContactRegion( POINT pt )
{
    m_iPreTime = ::GetTickCount();
    m_SelectedItem = GetClickedIndex( pt );
    return TRUE;
}

int ContactPanel::GetClickedIndex( POINT pt)
{
    int Index = 0;

    Index = pt.y / CONTACT_ITEM_HEIGHT + m_Offset;

    if ( !m_IsCategoryState )
    {
        if ( wcscmp( m_szCurrentCategoryName,L"All Contact") == 0  )
        {
            if ( Index >= m_ContactListData.m_vContactListItems.size() )
                Index = m_ContactListData.m_vContactListItems.size() - 1;
            DebugPrintString( L"1:::%d",Index);
        }
        else
            Index = GetSameGategoryIndex(  Index ) ;
    }
    else if ( m_IsCategoryState )
    {
        if (Index >= m_ContactListData.m_vContactListCategory.size())
            Index = m_ContactListData.m_vContactListCategory.size() - 1;
    }

    return Index;
}

int ContactPanel::GetSameGategoryIndex(int Index )
{
    int number = GetSameCategoryCount();
    int i = 0;
    int count =0;

    if ( Index >= number )
        Index = number -1;

    for ( i = 0; i < m_ContactListData.m_vContactListItems.size() && count <= Index ; i++ )
    {
        if ( wcscmp( m_szCurrentCategoryName,m_ContactListData.m_vContactListItems[i].szCategoriesText) == 0 )
            count++;
    }
    Index = i-1;
    return Index ;
}

int ContactPanel::GetSameCategoryCount()
{
    int count = 0;
    for ( int i = 0; i < m_ContactListData.m_vContactListItems.size(); i++)
    {
        if ( wcscmp( m_szCurrentCategoryName,m_ContactListData.m_vContactListItems[i].szCategoriesText) == 0 )
            count++;
    }
    return count;
}

BOOL  ContactPanel::ProcessMouseUpMenu ( POINT pt )
{
    switch ( m_eMenuState )
    {
    case eMenuIn:
        if ( PtInRect( &m_rcIn_MenuBar,m_pPreDown ) && PtInRect( &m_rcIn_MenuBar, pt) )
        {
            for ( int i=1; i <= 8; i++ )
            {
                BitBlt( m_hPublicMemoryDC,
                        m_rcIn_MenuBar.left -
                        (  m_rcIn_MenuBar.left - m_rcOut_MenuPanel.left) * i / 8 ,
                        m_rcOut_MenuPanel.top,
                        ( m_rcIn_MenuBar.right - m_rcOut_MenuPanel.left) * i / 8 + m_rcIn_MenuBar.left,
                        m_rcOut_MenuPanel.bottom - m_rcOut_MenuPanel.top ,
                        m_hMemoryDC,
                        0,
                        m_rcScreen.bottom,
                        SRCCOPY);
                Sleep(20);

                DrawMemDCToCurrentDC( m_hRealDC, m_hPublicMemoryDC, m_rcScreen );
            }
            m_eMenuState = eMenuOut;
        }
        else
            ProcessUpContactRegion(pt);
        break;

    case eMenuOut:
        if ( PtInRect( &m_rcOut_MenuBar,m_pPreDown ) && PtInRect( &m_rcOut_MenuBar, pt) )
        {
            for ( int i=0; i <= 8; i++ )
            {
                BitBlt( m_hPublicMemoryDC,
                        m_rcOut_MenuPanel.left,
                        m_rcOut_MenuPanel.top,
                        m_rcOut_MenuPanel.right - m_rcOut_MenuPanel.left ,
                        m_rcOut_MenuPanel.bottom - m_rcOut_MenuPanel.top ,
                        m_hMemoryDC,
                        m_rcScreen.right / 2,
                        m_rcScreen.bottom,
                        SRCCOPY);

                BitBlt( m_hPublicMemoryDC,
                        m_rcIn_MenuBar.left -
                        (  m_rcIn_MenuBar.left - m_rcOut_MenuPanel.left) * ( 8 - i ) / 8 ,
                        m_rcOut_MenuPanel.top,
                        ( m_rcIn_MenuBar.right - m_rcOut_MenuPanel.left) * ( 8 - i ) / 8
                        + m_rcIn_MenuBar.left,
                        m_rcOut_MenuPanel.bottom - m_rcOut_MenuPanel.top ,
                        m_hMemoryDC,
                        0,
                        m_rcScreen.bottom,
                        SRCCOPY);

                Sleep(20);

                DrawMemDCToCurrentDC( m_hRealDC, m_hPublicMemoryDC, m_rcScreen );
            }
            m_eMenuState = eMenuIn;
        }
        else if ( PtInRect( &m_rcOut_MenuRegion, m_pPreDown ) )
        {
            BitBlt( m_hPublicMemoryDC,
                    m_rcOut_MenuRegion.left,
                    m_rcOut_MenuRegion.top,
                    m_rcOut_MenuRegion.right - m_rcOut_MenuRegion.left ,
                    m_rcOut_MenuRegion.bottom - m_rcOut_MenuRegion.top ,
                    m_hMemoryDC,
                    m_rcIn_MenuBar.right - m_rcIn_MenuBar.left ,
                    m_rcScreen.bottom,
                    SRCCOPY
                  );

            ContactButton eParam ;
            RECT rect;
            CopyRect( &rect, &m_rcOut_MenuRegion );
            rect.bottom = rect.top ;

            for (int i=0; i<4; i++ )
            {
                rect.top  = rect.bottom ;
                rect.bottom = rect.top +
                              ( m_rcOut_MenuRegion.bottom - m_rcOut_MenuRegion.top  ) / 4 ;

                if ( PtInRect( &rect, pt )&&PtInRect( &rect, m_pPreDown ) )
                {
                    switch (i)
                    {
                    case 0:
                        m_IsCategoryState = TRUE;
                        wcscpy( m_szCurrentCategoryName,L"All Comtact");
                        Draw();
                        break;
                    case 1:
                        PoomAddItem() ;
                        Draw();
                        break;
                    case 2:
                        eParam = EditButton;
                        TransferProcessPoomClick( eParam );
                        break;
                    case 3:
                        eParam = DetailsButton;
                        TransferProcessPoomClick( eParam );
                        break;
                    }
                }
            }
        }
        else
        {
            ProcessUpContactRegion(pt);
        }
        break;
    default:
        break;
    }

    DrawMemDCToCurrentDC( m_hRealDC, m_hPublicMemoryDC, m_rcScreen );
    return TRUE;
}

BOOL ContactPanel:: TransferProcessPoomClick( ContactButton eParam )
{
    if ( m_ContactListData.m_vContactListItems.size()!=0 )
    {
        ContactDataItem  data = m_ContactListData.GetItem( m_SelectedItem ) ;
        ProcessPoomClick( &data , eParam ) ;
    }
    return TRUE;
}



BOOL ContactPanel::ProcessUpContactRegion( POINT pt )
{
    int temp = GetClickedIndex( pt );

    if ( !m_IsCategoryState && m_SelectedItem == temp )
    {
        if ( GetTickCount() - m_iPreTime > DAIL_LIMIT_TIME )
        {
            ContactButton eParam = DailPhoneButton ;
            TransferProcessPoomClick( eParam );
        }
        else
        {
            //...............
        }
    }
    else if ( m_IsCategoryState && m_SelectedItem ==  temp )
    {
        m_IsCategoryState = FALSE;
        wcscpy( m_szCurrentCategoryName,m_ContactListData.m_vContactListCategory[m_SelectedItem].m_szCurrentCategoryName );
        Draw();
    }
    return TRUE;
}

void ContactPanel::SnapBackToFrame()
{
}

HRESULT ContactPanel::ProcessPanEnd( HWND hwnd, int nTransitionSpeed, DWORD   nTransitionAngle )
{
    return S_OK;
}

BOOL ContactPanel::ProcessPan(long MoveDistance)
{
    return TRUE;
}


////////////////////////////////////////////////////////////////////////////////////////
//// These function are for the ContactListData class.
ContactListData:: ContactListData()
{
    m_listSelectedIndex = -1;
    m_hCache = INVALID_HANDLE_VALUE;
    m_szListCacheFn[0] = '\0';
    CoInitializeEx(NULL, 0);
}

void ContactListData:: ListClear(void)
{
    m_vContactListItems.clear();
    m_vContactListCategory.clear();
    m_listSelectedIndex = -1;
}

HRESULT ContactListData:: ListLoad( const TCHAR * szfilename, bool useCache )
{
    if ( szfilename != NULL )
    {
        return ListLoadFromCache( szfilename, useCache);
    }
    else
    {
        DebugPrintString(L"szfilename is NULL\n");
        return 0;
    }

}

HRESULT ContactListData:: ListLoadFromCache( const TCHAR * szfilename, bool useCache)
{
    HRESULT hr;

    GetCurrentDirFilename(m_szListCacheFn, szfilename );

    if ( m_hCache == INVALID_HANDLE_VALUE )
    {
        CHR( ListPopulate( szfilename ));

        m_hCache = CreateFile(m_szListCacheFn, GENERIC_READ, 0, NULL,
                              OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
    }

    DWORD dwFileSize = GetFileSize( m_hCache, NULL );

    ListClear();
    DWORD dwBytesRead;
    SetFilePointer(m_hCache, 0, NULL, FILE_BEGIN);
    ContactDataItem data;
    int n = 0;
    while ( n = ReadFile(m_hCache, &data, sizeof(ContactDataItem), &dwBytesRead, NULL) )
    {
        CBR(dwBytesRead == sizeof(ContactDataItem));
        m_vContactListItems.push_back(data);
    }
    hr = S_OK;

Error:
    CloseHandle(m_hCache);
    m_hCache = NULL;
    return hr;
}

HRESULT ContactListData:: ListPopulate( const TCHAR * szfilename )
{
    HRESULT hr;

    GetCurrentDirFilename( m_szListCacheFn, szfilename );

    m_hCache = CreateFile(m_szListCacheFn,
                          GENERIC_WRITE, 0, NULL,
                          CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);

    CHR( m_hCache != INVALID_HANDLE_VALUE );

    hr = PoomPopulate( WriteContactDataItemtoFile,m_hCache);
    CHR(hr);

    hr = S_OK;
Error:
    CloseHandle(m_hCache);
    m_hCache = NULL;
    return hr;
}

int ContactListData:: GetItemCount(void)
{
    return m_vContactListItems.size();
}

ContactDataItem ContactListData:: GetItem(int index)
{
    ASSERT(index >= 0 && index < (int)m_vContactListItems.size());
    return m_vContactListItems[index];
}

ContactListData::~ContactListData()
{
    ListClear();
    CoUninitialize();
}
