/*******************************************************************************************
This file is part of iToday.

iToday is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

iToday is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with iContact.  If not, see <http://www.gnu.org/licenses/>.
* ------------------------------------------------------------------------------
*    ContactPanel.h - Class ContactPanel declaration
* ------------------------------------------------------------------------------
*    Revision History
*    Date                  Author         Activity ID               Activity Headline
*    2009-10-13            Congqin				none						initial
*    2009-10-14            CubeWang				none						Modify the class method name
*    2009-10-26            CubeWang				none						add Gesture
*	 2009-10-28			   Congqin				none						add the ContactListData class
*******************************************************************************************/

#pragma once

#include "PanelBase.h"

#include "PoomUtility.h"

#define  CONTACT_ITEM_HEIGHT  60
#define  ONE				  1

#define  ITEM_FONT_SIZE		  50
#define  DAIL_LIMIT_TIME	  1000

typedef  enum
{
    eMenuIn,
    eMenuOut

} eMenuState;

class ContactListData
{
private:
    TCHAR					m_szListCacheFn[MAX_PATH];
    int						m_listSelectedIndex ;

public:
    std::vector<ContactDataItem>		m_vContactListItems; // ˳ϵ
    std::vector<ContactCategoryData>	m_vContactListCategory;//˳

    HANDLE					m_hCache; //ļľ

    ContactListData();

    void		ListClear(void);
    HRESULT		ListLoad(const TCHAR * szfilename,bool useCache = false );
    HRESULT		ListLoadFromCache( const TCHAR * szfilename, bool useCache);
    HRESULT		ListPopulate(const TCHAR * szfilename);
    ContactDataItem	GetItem( int index );
    int			GetItemCount( void );

    ~ContactListData();
};


class ContactPanel: virtual public PanelBase
{
private:

    ContactListData    m_ContactListData;//ݴ洢
    HFONT		m_ItemFont;// ContactPanelʾľ
    BOOL		m_IsCategoryState;//ǷԷʽʾ
    TCHAR		m_szCurrentCategoryName[SECONDARY_TEXT_LENGTH];//洢ǰʾϵ˵
    INT			m_Offset;//ƫ
    RECT		m_rcIn_MenuBar;//menu panelʱڵ
    RECT		m_rcOut_MenuPanel;//menu panelڵ
    RECT		m_rcOut_MenuBar;
    RECT		m_rcOut_MenuRegion;
    eMenuState	m_eMenuState;//¼menu Panel״̬
    POINT		m_pPreDown;//¼ȥ

    int			m_iPreTime;//¼ȥʱʱ
    int			m_SelectedItem;//¼ѡеϵ˵ı

protected:

public:
    HDC			m_hMemoryDC	;
    HBITMAP		m_hMemoryBm	;

    ContactPanel(HWND hWnd, HINSTANCE hInstance);

    BOOL	InitMemoryDC();
    BOOL	DrawMemoryDC();
    LONG	DrawContactTxt();
    LONG 	DrawCategoryTxt();
    BOOL	DrawItem( RECT rect,  TCHAR* szItemName );
    void	Draw();

    int		GetClickedIndex( POINT pt);
    BOOL	TransferProcessPoomClick( ContactButton eParam );
    int		GetSameGategoryIndex( int Index );
    int		GetSameCategoryCount();
    BOOL	DrawMouseDownMenu( POINT pt );
    BOOL	ProcessDownContactRegion( POINT pt );

    BOOL	ProcessMouseUpMenu ( POINT pt );
    BOOL	ProcessUpContactRegion( POINT pt );
    //////////////////////////////////////////////////////////////////////////
    ///Gesture and Animation
    void SnapBackToFrame();	//Stop Animation, bring the content back into the visible area

    HRESULT
    ProcessPanEnd(		//Processes the end gesture and figures out what
        // physics engine animation is needed
        HWND    hwnd,
        int     nTransitionSpeed,            // @parm Start speed of animation (relevant for flick end gesture). Must be a posative value
        DWORD   nTransitionAngle             // @parm Angle for start speed (relevant for flick end gesture)
    );

    BOOL ProcessPan(long MoveDistance);
    //////////////////////////////////////////////////////////////////////////

    ~ContactPanel() { }

};



