/*******************************************************************************************
This file is part of iToday.

iToday is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

iToday is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with iContact.  If not, see <http://www.gnu.org/licenses/>.
* ------------------------------------------------------------------------------
*    FileUtility.cpp - The implement of File I/O utility
* ------------------------------------------------------------------------------
*    Revision History
*    Date                  Author         Activity ID               Activity Headline
*    2009-10-13            Congqin				none						initial
*******************************************************************************************/

#include "stdafx.h"

BOOL RegReadKey(HKEY hRootKey/*[in]*/,
                LPCWSTR lpSubKeyName/*[in]*/,
                LPCWSTR lpSubKeyValueName/*[in]*/,
                LPBYTE lpSubKeyValueBuf/*[in,out]*/,
                LPDWORD lpBufSize/*[in,out]*/)
{
    if (!lpSubKeyName || !lpSubKeyValueName || !lpSubKeyValueBuf || !lpBufSize)
        return FALSE;

    HKEY hKey;
    BOOL ret = FALSE;
    if (ERROR_SUCCESS == RegOpenKeyEx(hRootKey, lpSubKeyName, 0, 0, &hKey))
    {
        RegQueryValueEx(hKey, lpSubKeyValueName, 0, 0, lpSubKeyValueBuf, lpBufSize);
        if (ERROR_SUCCESS == GetLastError())
            ret = TRUE;
    }
    RegCloseKey(hKey);
    return ret;
}



void GetCurrentDirFilename(TCHAR * szFilename, const TCHAR * filename,
                           const TCHAR * extension)
{

    ::GetModuleFileName(NULL, szFilename, MAX_PATH);
    TCHAR * pstr = _tcsrchr(szFilename, '\\');
    if ( pstr )
        *(++pstr) = '\0';
    StringCchCat(szFilename, MAX_PATH, filename);
    if (extension != NULL)
    {
        StringCchCat(szFilename, MAX_PATH, TEXT("."));
        StringCchCat(szFilename, MAX_PATH, extension);
    }
}

void WriteContactDataItemtoFile(ContactDataItem * data ,HANDLE hCache)
{
    DWORD dwNumberOfBytesWritten;
    wprintf(data->szPrimaryText);
    printf("\n");
    WriteFile( hCache, data, sizeof(ContactDataItem), &dwNumberOfBytesWritten, NULL);
}

//崴
HFONT BuildFont(int iFontSize, BOOL bBold, BOOL bItalic)
{
    LOGFONT lf;
    memset(&lf, 0, sizeof(LOGFONT));

    lf.lfHeight = iFontSize;
    lf.lfWidth = 0;
    lf.lfEscapement = 0;
    lf.lfOrientation = 0;
    lf.lfWeight = bBold ? 600 : 500;
    lf.lfItalic = bItalic;
    lf.lfUnderline = false;
    lf.lfStrikeOut = false;
    lf.lfCharSet = EASTEUROPE_CHARSET;
    lf.lfOutPrecision = OUT_RASTER_PRECIS;
    lf.lfClipPrecision = CLIP_DEFAULT_PRECIS;
    lf.lfQuality = CLEARTYPE_QUALITY;
    lf.lfPitchAndFamily = DEFAULT_PITCH | FF_DONTCARE;
    _tcsncpy (lf.lfFaceName, TEXT("Tahoma"), LF_FACESIZE);
    //lf.lfFaceName[LF_FACESIZE-1] = L'\0';  // Ensure null termination
    return CreateFontIndirect(&lf);

}