/*******************************************************************************************
This file is part of iToday.

iToday is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

iToday is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with iContact.  If not, see <http://www.gnu.org/licenses/>.
* ------------------------------------------------------------------------------
*    Public.h ---- the delaration of public class
* ------------------------------------------------------------------------------
*    Revision History
*    Date                  Author         Activity ID               Activity Headline
*    2009-10-10            Congqin          none                     initial
*******************************************************************************************/

#pragma once

#include <imaging.h>


class RectEx : public RECT
{
public:
    RectEx();
    RectEx(int left, int top, int right, int bottom);
    operator RECT(void);
    const RectEx& operator = (const RectEx& rcex);
};

class PointEx : public POINT
{
public:
    PointEx();
    PointEx(int cx, int cy);
    operator POINT(void);
    const PointEx& operator = (const PointEx& rcex);
};


/**********************************************************************************/
// declaration of the function

void	DrawImage(HDC ,RECT,TCHAR*);
BOOL	AlphaBlt(HDC hdcDest, int nXOriginDest, int nYOriginDest,
              int nWidthDest, int nHeightDest,
              HDC hdcSrc, int nXOriginSrc, int nYoriginSrc,
              int nWidthSrc, int nHeightSrc,
              BYTE alpha);
void	DrawStringData(HDC hdc, LPCTSTR data, RECT& rc, LOGFONT lfFont );
void	DrawNumber(HDC hdc, int num, RECT& rc);

BOOL	DrawMemDCToCurrentDC( HDC CurrentDC, HDC PublicMemoryDC, RECT rect);
/**********************************************************************************/

class DrawImageClass
{
private:
    IImagingFactory *    pImgFactory ;
    IImage *             pImage		 ;

public:
    DrawImageClass();
    BOOL DrawImageToDC(HDC hdc, RECT rc, TCHAR* ppPhotoFile);
    ~DrawImageClass();


};

/**********************************************************************************/
