/*******************************************************************************************
This file is part of iToday.

iToday is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

iToday is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with iContact.  If not, see <http://www.gnu.org/licenses/>.
* ------------------------------------------------------------------------------
*    Utility.cpp - implement tool for debug info print and other common functions
* ------------------------------------------------------------------------------
*    Revision History
*    Date                  Author         Activity ID               Activity Headline
*    2009-06-18            CubeWang          none                     initial
*******************************************************************************************/

#include "stdafx.h"
#include "LogUtility.h"


void DebugPrintString(const TCHAR *format, ... )
{
    va_list args;

    va_start(args, format);
#ifdef _LOG_

    FILE *fpLog;

    fpLog = fopen("DebugInfo.log", "a+");  // "a+" appends context to the end of the file.
    if (fpLog)
    {
        vfprintf(fpLog, format, args);
        fflush(fpLog);
        fclose(fpLog);
    }

#else
    vwprintf(/*stdout, */format, args);
#endif

    va_end(args);

}
