/*******************************************************************************************
This file is part of iToday.

iToday is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

iToday is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with iContact.  If not, see <http://www.gnu.org/licenses/>.
* ------------------------------------------------------------------------------
*    PanelBase.cpp - Class PanelBase implement
* ------------------------------------------------------------------------------
*    Revision History
*    Date                  Author         Activity ID               Activity Headline
*    2009-10-13            Congqin				none						initial
*******************************************************************************************/

#include "stdafx.h"
#include "PanelBase.h"

HDC	PanelBase::m_hPublicMemoryDC =NULL ;
HDC	PanelBase::m_hPublicSwitchMemoryDC =NULL ;

PanelBase::PanelBase( HWND hWnd, HINSTANCE hInstance )
{
    m_hWnd = hWnd;
    m_hInst = hInstance;
    GetClientRect( hWnd, &m_rcScreen );
    m_hRealDC = GetDC( m_hWnd );
    InitMemoryDC();

}

BOOL PanelBase::InitMemoryDC()
{
    m_hPublicMemoryDC = CreateCompatibleDC( m_hRealDC );
    if ( NULL == m_hPublicMemoryDC )
    {
        DebugPrintString(L"create the m_hPublicMemoryDC is failure! " );
        return FALSE;
    }
    m_hPublicMemoryBm = CreateCompatibleBitmap( m_hRealDC, m_rcScreen.right, m_rcScreen.bottom  );
    if ( NULL == m_hPublicMemoryBm )
    {
        DebugPrintString(L"create the m_hPublicMemoryBm is failure! ! " );
        return FALSE;
    }
    SelectObject( m_hPublicMemoryDC, m_hPublicMemoryBm );

    m_hPublicSwitchMemoryDC = CreateCompatibleDC( m_hRealDC );
    if ( NULL == m_hPublicSwitchMemoryDC )
    {
        DebugPrintString(L"create the m_hPublicSwitchMemoryDC is failure! " );
        return FALSE;
    }
    m_hPublicSwitchMemoryBm = CreateCompatibleBitmap( m_hRealDC, m_rcScreen.right, m_rcScreen.bottom  );
    if ( NULL == m_hPublicSwitchMemoryBm )
    {
        DebugPrintString(L"create the m_hPublicSwitchMemoryBm is failure! ! " );
        return FALSE;
    }
    SelectObject( m_hPublicSwitchMemoryDC, m_hPublicSwitchMemoryBm );

    return TRUE;
}

PanelBase::~PanelBase()
{
    ReleaseDC( m_hWnd, m_hRealDC );
}


