/*******************************************************************************************
This file is part of iToday.

iToday is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

iToday is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with iContact.  If not, see <http://www.gnu.org/licenses/>.
* ------------------------------------------------------------------------------
*    PanelBase.h - Class PanelBase declaration, all panels inherit from this class
* ------------------------------------------------------------------------------
*    Revision History
*    Date                  Author         Activity ID               Activity Headline
*    2009-10-13            Congqin				none						initial
*    2009-10-14            CubeWang				none		Ϊ˹ܸһЩԱPanelManager
															ȻΪ࣬䷽ԱҪ㹻
*    2009-10-26            CubeWang				none						add Gesture
*******************************************************************************************/

#pragma once

#define GESTURE_ANIMATION_TIMER_ID 10
#define GESTURE_ANIMATION_FRAME_REFRESH_MS 34

typedef enum
{
    Empty,
    Contact,
    Home,
    eAppPanel,
    Picture
} PANEL;

typedef enum
{
    PanelRegion,
    SwitcherRegion
} ClICKREGION;


class PanelBase
{
private:
protected:

    HINSTANCE			m_hInst;
    HWND				m_hWnd;
    RECT				m_rcScreen;

    HDC					m_hRealDC;

    UINT				m_uAnimationTimerId;
    POINT				m_ptLastPan;

public:

    static	HDC			m_hPublicMemoryDC ;
    HBITMAP				m_hPublicMemoryBm ;
    static	HDC			m_hPublicSwitchMemoryDC ;
    HBITMAP				m_hPublicSwitchMemoryBm ;


    PanelBase( HWND hWnd, HINSTANCE hInstance ) ;
    BOOL InitMemoryDC();

    //////////////////////////////////////////////////////////////////////////
    ///Gesture and Animation
    virtual void SnapBackToFrame() {}	//Stop Animation, bring the content back into the visible area
    virtual HRESULT
    ProcessPanEnd(		//Processes the end gesture and figures out what physics engine animation is needed
        int     nTransitionSpeed,            // @parm Start speed of animation (relevant for flick end gesture). Must be a posative value
        DWORD   nTransitionAngle             // @parm Angle for start speed (relevant for flick end gesture)
    )
    {
        return S_OK;
    }
    virtual BOOL ProcessAnimationTimer()
    {
        return TRUE;
    }
    virtual BOOL ProcessPan(POINTS& pt)
    {
        return TRUE;
    }
    virtual BOOL RecordLastPanPoint( POINTS& pt )
    {
        return TRUE;
    }
    virtual BOOL CalculateStartPointInMemDC( POINTS& pt )
    {
        return TRUE;
    }
    //////////////////////////////////////////////////////////////////////////

    ~PanelBase();

};
