/*******************************************************************************************
This file is part of iToday.

iToday is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

iToday is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with iContact.  If not, see <http://www.gnu.org/licenses/>. 
* ------------------------------------------------------------------------------
*    PanelManager.h - Class PanelManager declaration
* ------------------------------------------------------------------------------
*    Revision History
*    Date                  Author         Activity ID               Activity Headline
*    2009-10-13            Congqin				none						initial 
*    2009-10-14            CubeWang             none               عPanelManager࣬ϵUI߼ȶ
                                                                    PanelManagerͷַ
*    2009-10-26            CubeWang				none						add Gesture 
*******************************************************************************************/

#pragma once
#include "HomePanel.h"
#include "ApplicationPanel.h"
#include "ContactPanel.h"
#include "PicturePanel.h"
#include "Switcher.h"


DWORD WINAPI ThreadProc1( PVOID pParam );

class PanelManager
{
private:
	HINSTANCE			m_hInst;
	HWND				m_hWnd;
	RECT				m_rcScreen;
	HDC					m_hRealDC;

	HDC					m_hBackGroundMemoryDC;
	HBITMAP				m_hBackGroundMemoryBm;

	//////////////////////////////////////////////////////////////////////////
	//Gesture and Animation
	bool				m_fAnimating;

	//////////////////////////////////////////////////////////////////////////

	ClICKREGION		m_ClickRegionState;	//ڱǴPanel/Switcher˭WM_LBUTTONDOWNϢ
										//ķַWM_GESTUREϢķַ

	//PanelBase		*m_pClickedPanel;		//m_ClickRegionStatem_ActivedPanelֵǰPanelָ뱣
	RECT			m_rcClickedRegion;
	

	//friend DWORD WINAPI ThreadProc1( PVOID pParam );

protected:

public:
	//All panels PanelManager managed
	ApplicationPanel	m_ApplicationPanel;
	PicturePanel		m_PicturePanel;
	ContactPanel		m_ContactPanel;
	HomePanel			m_HomePanel;
	Switcher			m_Switcher;

	PANEL			m_ActivedPanel;

	PanelManager(HWND hWnd, HINSTANCE hInstance);

	BOOL	InitPanelHeadmost();	//ʼHomePanelûܹĽ
	BOOL	InitPanelLater();		//ʹ߳ԺʼûĽ
	BOOL	InitPublicMemoryDC();
	void	InitMenuMemData();
	void	DrawPublicMemoryDC();

	BOOL	InitData();		//ʼݣInitPanelHeadmost(),InitPanelLater()
	void	InitForepartCurrentDC();
	void	Draw();
	void	RefreshPanel( HDC hPublicMemoryDC  );
	BOOL	ProcessMouseDownEvent( POINT pt ) ;
	BOOL	ProcessAllPanels(  PANEL panel, POINT pt, BOOL IsInitForepart );

	BOOL	DrawMouseDownMenu( POINT pt,BOOL IsInitForepart);
	BOOL	DrawMouseUpMenu();
	BOOL	ProcessMouseUpEvent(  POINT pt);

	PanelBase * GetClickedPanelPoint();

	//////////////////////////////////////////////////////////////////////////
	//Gesture and Animation
	BOOL	ProcessGesture(HWND hWnd, UINT, WPARAM wParam, LPARAM lParam);

	//////////////////////////////////////////////////////////////////////////


~PanelManager();

};
