/*******************************************************************************************
This file is part of iToday.

iToday is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

iToday is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with iContact.  If not, see <http://www.gnu.org/licenses/>.
* ------------------------------------------------------------------------------
*    Switcher.h - Class Switcher implement
* ------------------------------------------------------------------------------
*    Revision History
*    Date                  Author         Activity ID               Activity Headline
*    2009-10-14            CubeWang				none						initial
*******************************************************************************************/

#include "stdafx.h"

//static HPHYSICSENGINE g_hPhysicsEngine = NULL;

Switcher::Switcher(HWND hWnd, HINSTANCE hInstance):PanelBase( hWnd, hInstance)
{

}

Switcher::~Switcher()
{}

BOOL Switcher::DrawMouseDownMenu( POINT pt, RECT rcScreen ,BOOL IsInitForepart )
{
    RECT	rect ={ 0, 0, 0, 0 };

    for ( int i=0; i<4; i++ )
    {
        rect.bottom =  rcScreen.bottom;
        rect.top	=  rect.bottom  - rcScreen.right / 5 ;
        rect.left   =  (rcScreen.right/5) * (i % 4) + (rcScreen.right/25 )*(1 + i%4);
        rect.right  =  rect.left + (rcScreen.right/ 5);

        if ( PtInRect( &rect, pt) )
        {
            BitBlt( m_hPublicMemoryDC,
                    rcScreen.left , rcScreen.bottom - rcScreen.right/5,
                    rcScreen.right - rcScreen.left, rcScreen.right / 5,
                    m_hSwitcherMemoryDC,
                    rcScreen.left, rcScreen.right /5,
                    SRCCOPY
                  );
            BitBlt( m_hPublicMemoryDC,
                    rect.left, rect.top,
                    rect.right - rect.left, rect.bottom - rect.top,
                    m_hSwitcherMemoryDC,
                    rect.left, rcScreen.top,
                    SRCCOPY
                  );
            if ( IsInitForepart== TRUE )
                return TRUE;

            GlideSwitchPanel( );
            //DrawMemDCToCurrentDC( m_hRealDC, m_hPublicMemoryDC, rcScreen );
            return TRUE;
        }

    }
    return FALSE ;
}

BOOL Switcher::GlideSwitchPanel( )
{
    for ( int i=1; i< 9; i++ )
    {
        BitBlt( m_hRealDC,
                m_rcScreen.left,
                m_rcScreen.top ,
                m_rcScreen.right  - m_rcScreen.right *i/8,
                m_rcScreen.bottom - m_rcScreen.right/5,
                m_hPublicSwitchMemoryDC,
                m_rcScreen.right *  i / 8 ,
                m_rcScreen.top ,
                SRCCOPY
              );
        BitBlt( m_hRealDC,
                m_rcScreen.right - m_rcScreen.right * i/8 ,
                m_rcScreen.top ,
                m_rcScreen.right * i /8 ,
                m_rcScreen.bottom - m_rcScreen.right/5 ,
                m_hPublicMemoryDC,
                m_rcScreen.left,
                m_rcScreen.top ,
                SRCCOPY
              );
        Sleep( 20 );
    }
    BitBlt( m_hRealDC,
            m_rcScreen.left  ,
            m_rcScreen.bottom - m_rcScreen.right/5,
            m_rcScreen.right ,
            m_rcScreen.right/5 ,
            m_hPublicMemoryDC,
            m_rcScreen.left  ,
            m_rcScreen.bottom - m_rcScreen.right/5,
            SRCCOPY
          );
    return TRUE;
}


BOOL Switcher::InitMemoryDC( HDC hBackGroundMemoryDc )
{
    m_hSwitcherMemoryDC = CreateCompatibleDC( m_hRealDC );
    if ( NULL == m_hSwitcherMemoryDC )
    {
        DebugPrintString(L"MainThread: Switcher::InitMemoryDC: create the m_hSwitcherMemoryDC is failure! " );
        return FALSE;
    }

    m_hMainMenuMemBm = CreateCompatibleBitmap( m_hRealDC, m_rcScreen.right,
                       m_rcScreen.right*2/5 );
    if ( NULL == m_hMainMenuMemBm )
    {
        DebugPrintString(L"MainThread: Switcher::InitMemoryDC: create the m_hMainMenuMemBm is failure! " );
        return FALSE;
    }

    SelectObject( m_hSwitcherMemoryDC,m_hMainMenuMemBm );

    DrawMemoryDC( hBackGroundMemoryDc );

    return TRUE;

}

void Switcher:: DrawMemoryDC( HDC hBackGroundMemoryDc )
{

    RECT	rect;
    RECT	rc = { m_rcScreen.left ,
                m_rcScreen.top,
                m_rcScreen.right,
                m_rcScreen.right / 5
              };

    DrawImageClass*  drawDC = new DrawImageClass();

    TCHAR* pTimeFile = RES_PATH("LS_TimeBG.png");


    BitBlt( m_hSwitcherMemoryDC, 0, 0,
            m_rcScreen.right, m_rcScreen.right / 5,
            hBackGroundMemoryDc, 0, m_rcScreen.bottom  - m_rcScreen.right / 5,
            SRCCOPY
          );

    drawDC ->DrawImageToDC ( m_hSwitcherMemoryDC, rc, pTimeFile );

    BitBlt( m_hSwitcherMemoryDC, 0, m_rcScreen.right / 5,
            m_rcScreen.right, m_rcScreen.right / 5,
            m_hSwitcherMemoryDC, 0, 0,
            SRCCOPY
          );

    TCHAR* pMainPhotoFile[] =
    {
        RES_PATH("Start_Icon_Messenger.png"),
        RES_PATH("Start_Icon_Today.png"),
        RES_PATH("Start_Icon_Connections.png"),
        RES_PATH("Start_Icon_Photos.png"),
    };
    // switchĸPanelͼ꼰䱳m_hSwitcherMemoryDC ϰ벿֡
    for ( int i=0; i < SIZEBUFFER( pMainPhotoFile ); i++ )
    {
        rect.top	= m_rcScreen.top ;
        rect.bottom = m_rcScreen.right / 5;
        rect.left   = (m_rcScreen.right/5) * (i % 4) + (m_rcScreen.right/25 )*(1 + i%4);
        rect.right  = rect.left + (m_rcScreen.right/ 5);

        drawDC ->DrawImageToDC ( m_hSwitcherMemoryDC, rect, pMainPhotoFile[i] );

    }
    delete drawDC;
    // switchĸ͸Panelͼ꼰䱳m_hSwitcherMemoryDC °벿֡

    AlphaBlt(m_hSwitcherMemoryDC,
             rc.left, rc.bottom , rc.right - rc.left, rc.bottom - rc.top,
             m_hSwitcherMemoryDC,
             rc.left, rc.top, rc.right - rc.left, rc.bottom - rc.top,
             150);

    return ;

}

PANEL Switcher::GetWhichPanelClicked(POINT pt)
{
    RECT rect;

    for (int i=0; i<4; i++)
    {
        rect.left = ( m_rcScreen.right / 5 ) * ( i % 4 ) +
                    ( m_rcScreen.right / 25 ) * ( 1 + i % 4 );
        rect.right = rect.left  + ( m_rcScreen.right / 5 );
        rect.top = m_rcScreen.bottom - m_rcScreen.right /5;
        rect.bottom  = m_rcScreen.bottom ;

        if ( PtInRect( &rect, pt ) )
            return (PANEL)(i+1);
    }
    return Empty;

}

void Switcher::SnapBackToFrame()
{}

HRESULT Switcher::ProcessPanEnd( int nTransitionSpeed, DWORD   nTransitionAngle )
{
    return S_OK;
}

BOOL Switcher::ProcessPan(POINTS& pt)
{
    return TRUE;
}

BOOL Switcher::ProcessAnimationTimer()
{
    return TRUE;
}

BOOL Switcher::RecordLastPanPoint( POINTS& pt )
{
    return TRUE;
}

BOOL Switcher::CalculateStartPointInMemDC( POINTS& pt )
{
    return TRUE;
}